=== modified file 'DistUpgrade/DistUpgradeQuirks.py'
--- DistUpgrade/DistUpgradeQuirks.py	2012-05-28 11:11:59 +0000
+++ DistUpgrade/DistUpgradeQuirks.py	2012-06-11 15:08:35 +0000
@@ -37,7 +37,7 @@
 from .utils import lsmod, get_arch
 
 from .DistUpgradeGettext import gettext as _
-from computerjanitor.plugin import PluginManager
+from janitor.plugincore.manager import PluginManager
 
 class DistUpgradeQuirks(object):
     """

=== modified file 'DistUpgrade/build-tarball.sh'
--- DistUpgrade/build-tarball.sh	2012-06-04 12:27:29 +0000
+++ DistUpgrade/build-tarball.sh	2012-06-11 15:08:35 +0000
@@ -7,7 +7,7 @@
 # cleanup
 echo "Cleaning up"
 
-for d in ./ plugins/ computerjanitor/; do
+for d in ./ janitor/; do
     rm -f $d/*~ $d/*.bak $d/*.pyc $d/*.moved $d/'#'* $d/*.rej $d/*.orig
     rm -rf $d/__pycache__
     rm -f *.tar.gz *.tar

=== modified file 'debian/update-manager-core.dirs'
--- debian/update-manager-core.dirs	2010-03-19 09:51:03 +0000
+++ debian/update-manager-core.dirs	2012-06-11 15:08:35 +0000
@@ -4,4 +4,4 @@
 etc/update-motd.d
 etc/update-manager/release-upgrades.d
 usr/bin
-usr/share/computerjanitor/plugins
+usr/lib/python*/dist-packages/janitor

=== modified file 'debian/update-manager-core.install'
--- debian/update-manager-core.install	2011-06-02 19:01:45 +0000
+++ debian/update-manager-core.install	2012-06-11 15:08:35 +0000
@@ -7,8 +7,7 @@
 debian/tmp/usr/lib/python*/dist-packages/UpdateManager/fdsend.so
 debian/tmp/usr/lib/python*/dist-packages/UpdateManager/__init__.py
 debian/tmp/usr/lib/python*/dist-packages/DistUpgrade
-debian/tmp/usr/lib/python*/dist-packages/computerjanitor
-debian/tmp/usr/share/computerjanitor
+debian/tmp/usr/lib/python*/dist-packages/janitor
 debian/release-upgrade-motd usr/lib/update-manager
 debian/91-release-upgrade etc/update-motd.d/
 debian/source_update-manager.py /usr/share/apport/package-hooks/

=== added directory 'janitor'
=== added file 'janitor/__init__.py'
--- janitor/__init__.py	1970-01-01 00:00:00 +0000
+++ janitor/__init__.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,24 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# The following license applies to all files (including the icons):
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+
+# This is a namespace package.
+try:
+    import pkg_resources
+    pkg_resources.declare_namespace(__name__)
+except ImportError:
+    import pkgutil
+    __path__ = pkgutil.extend_path(__path__, __name__)

=== added directory 'janitor/plugincore'
=== added file 'janitor/plugincore/NEWS.rst'
--- janitor/plugincore/NEWS.rst	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/NEWS.rst	2012-06-11 15:08:35 +0000
@@ -0,0 +1,7 @@
+============================
+NEWS for janitor.plugincore
+============================
+
+1.0 (2012-XX-XX)
+================
+ * Initial release since refactoring into a separate package.

=== added file 'janitor/plugincore/__init__.py'
--- janitor/plugincore/__init__.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/__init__.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,17 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# The following license applies to all files (including the icons):
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+__version__ = '1.0'

=== added directory 'janitor/plugincore/core'
=== added file 'janitor/plugincore/core/__init__.py'
=== added file 'janitor/plugincore/core/file_cruft.py'
--- janitor/plugincore/core/file_cruft.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/core/file_cruft.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,53 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+
+import os
+
+from janitor.plugincore.cruft import Cruft
+from janitor.plugincore.i18n import setup_gettext
+_ = setup_gettext()
+
+
+class FileCruft(Cruft):
+    """Cruft that is individual files.
+
+    This type of cruft consists of individual files that should be removed.
+    Various plugins may decide that various files are cruft; they can all use
+    objects of FileCruft type to mark such files, regardless of the reason the
+    files are considered cruft.
+    """
+
+    def __init__(self, pathname, description):
+        self.pathname = pathname
+        self._disk_usage = os.stat(pathname).st_blocks * 512
+        self._description = description
+
+    def get_prefix(self):
+        return 'file'
+
+    def get_prefix_description(self):
+        return _('A file on disk')
+
+    def get_shortname(self):
+        return self.pathname
+
+    def get_description(self):
+        return '{}\n'.format(self._description)
+
+    def get_disk_usage(self):
+        return self._disk_usage
+
+    def cleanup(self):
+        os.remove(self.pathname)

=== added file 'janitor/plugincore/core/missing_package_cruft.py'
--- janitor/plugincore/core/missing_package_cruft.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/core/missing_package_cruft.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,52 @@
+# Copyright (C) 2009-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'MissingPackageCruft',
+    ]
+
+
+from janitor.plugincore.cruft import Cruft
+from janitor.plugincore.i18n import setup_gettext
+_ = setup_gettext()
+
+
+class MissingPackageCruft(Cruft):
+    """Install a missing package."""
+
+    def __init__(self, package, description=None):
+        self.package = package
+        self._description = description
+
+    def get_prefix(self):
+        return 'install-deb'
+
+    def get_prefix_description(self):
+        return _('Install missing package.')
+
+    def get_shortname(self):
+        return self.package.name
+
+    def get_description(self):
+        if self._description:
+            return self._description
+        else:
+            # 2012-06-08 BAW: i18n string; don't use {} or PEP 292.
+            return _('Package %s should be installed.') % self.package.name
+
+    def cleanup(self):
+        self.package.markInstall()

=== added file 'janitor/plugincore/core/package_cruft.py'
--- janitor/plugincore/core/package_cruft.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/core/package_cruft.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,61 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'PackageCruft',
+    ]
+
+
+from janitor.plugincore.cruft import Cruft
+from janitor.plugincore.i18n import setup_gettext
+_ = setup_gettext()
+
+
+class PackageCruft(Cruft):
+    """Cruft that is .deb packages.
+
+    This type of cruft consists of .deb packages installed onto the system
+    which can be removed.  Various plugins may decide that various packages
+    are cruft; they can all use objects of PackageCruft type to mark such
+    packages, regardless of the reason the packages are considered cruft.
+
+    When PackageCruft instantiated, the package is identified by an
+    apt.Package object.  That object is used for all the real operations, so
+    this class is merely a thin wrapper around it.
+    """
+
+    def __init__(self, pkg, description):
+        self._pkg = pkg
+        self._description = description
+
+    def get_prefix(self):
+        return 'deb'
+
+    def get_prefix_description(self):
+        return _('.deb package')
+
+    def get_shortname(self):
+        return self._pkg.name
+
+    def get_description(self):
+        return '{}\n\n{}'.format(self._description, self._pkg.summary)
+
+    def get_disk_usage(self):
+        return self._pkg.installedSize
+
+    def cleanup(self):
+        self._pkg.markDelete()

=== added file 'janitor/plugincore/cruft.py'
--- janitor/plugincore/cruft.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/cruft.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,159 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'Cruft',
+    ]
+
+
+from janitor.plugincore.i18n import setup_gettext
+_ = setup_gettext()
+
+
+from janitor.plugincore.exceptions import UnimplementedMethod
+
+
+class Cruft:
+    """One piece of cruft to be cleaned out.
+
+    A piece of cruft can be a file, a package, a configuration tweak that is
+    missing, or something else.
+
+    This is a base class, which does nothing. Subclasses do the actual work,
+    though they must override the `get_shortname()` and `cleanup()` methods.
+    """
+
+    def get_prefix(self):
+        """Return the unique prefix used to group this type of cruft.
+
+        For example, the .deb package called 'foo' would have a prefix
+        of 'deb'. This way, the package foo is not confused with the
+        file foo, or the username foo.
+
+        Subclasses SHOULD define this. The default implementation
+        returns the name of the class, which is rarely useful to
+        the user.
+        """
+        return self.__class__.__name__
+
+    @property
+    def prefix(self):
+        return self.get_prefix()
+
+    def get_prefix_description(self):
+        """Return human-readable description of class of cruft."""
+        return self.get_description()
+
+    @property
+    def prefix_description(self):
+        return self.get_prefix_description()
+
+    def get_shortname(self):
+        """Return the name of this piece of cruft.
+
+        The name should be something that the user will understand.  For
+        example, it might be the name of a package, or the full path to a
+        file.
+
+        The name should be unique within the unique prefix returned by
+        `get_prefix()`.  The prefix MUST NOT be included by this method, the
+        `get_name()` method does that instead.  The intent is that
+        `get_shortname()` will be used by the user interface in contexts where
+        the prefix is shown separately from the short name, and `get_name()`
+        when a single string is used.
+
+        Subclasses MUST define this.  The default implementation raises an
+        exception.
+        """
+        raise UnimplementedMethod(self.get_shortname)
+
+    @property
+    def shortname(self):
+        return self.get_shortname()
+
+    def get_name(self):
+        """Return prefix plus name.
+
+        See `get_prefix()` and `get_shortname()` for a discussion of the
+        prefix and the short name.  This method will return the prefix, a
+        colon, and the short name.
+
+        The long name will used to store state/configuration data: _this_
+        package should not be removed.
+        """
+        return '{}:{}'.format(self.prefix, self.shortname)
+
+    @property
+    def name(self):
+        return self.get_name()
+
+    def __repr__(self):
+        return '<{} "{}">'.format(self.__class__.__name__, self.name)
+
+    def get_description(self):
+        """Return a description of this piece of cruft.
+
+        This may be arbitrarily long.  The user interface will take care of
+        breaking it into lines or otherwise presenting it to the user in a
+        nice manner.  The description should be plain text UTF-8 unicode.
+
+        The default implementation returns the empty string.  Subclasses MAY
+        override this as they wish.
+        """
+        return ''
+
+    @property
+    def description(self):
+        return self.get_description()
+
+    def get_disk_usage(self):
+        """Return amount of disk space reserved by this piece of cruft.
+
+        The unit is bytes.
+
+        The disk space in question should be the amount that will be freed if
+        the cruft is cleaned up.  The amount may be an estimate (i.e. a
+        guess).  It is intended to be shown to the user to help them decide
+        what to remove and what to keep.
+
+        This will also be used by the user interface to better estimate how
+        much remaining time there is when cleaning up a lot of cruft.
+
+        For some types of cruft, this is not applicable and they should return
+        `None`.  The base class implementation does that, so subclasses MUST
+        define this method if it is useful for them to return something else.
+
+        The user interface will distinguish between None (not applicable) and
+        0 (no disk space being used).
+        """
+        return None
+
+    @property
+    def disk_usage(self):
+        return self.get_disk_usage()
+
+    def cleanup(self):
+        """Clean up this piece of cruft.
+
+        Depending on the type of cruft, this may mean removing files,
+        packages, modifying configuration files, or something else.
+
+        The default implementation raises an exception.  Subclasses MUST
+        override this.
+        """
+        raise UnimplementedMethod(self.cleanup)

=== added directory 'janitor/plugincore/docs'
=== added file 'janitor/plugincore/docs/README.rst'
--- janitor/plugincore/docs/README.rst	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/docs/README.rst	2012-06-11 15:08:35 +0000
@@ -0,0 +1,201 @@
+=========================
+Computer Janitor plugins
+=========================
+
+Computer Janitor supports a plugin architecture which allows you to add
+additional ways of identifying and cleaning up *cruft*.  Cruft is anything on
+your system that is no longer necessary and can be safely removed.
+
+Identifying cruft is the primary purpose of plugins, and each plugin should
+identify exactly one kind of cruft.
+
+The primary interface for this is the `get_cruft()` method on each plugin.
+This method should return an iterator over cruft objects, which allows for the
+UI to provide useful progress feedback.
+
+
+Cruft
+=====
+
+Cruft objects themselves must implement a specific interface, which is used to
+provide information to the user, and to perform the actual clean up
+operations.  There is a useful base class that you can start with.
+
+    >>> from janitor.plugincore.cruft import Cruft
+
+You can derive from this base class, but you must implement a couple of
+methods, or your cruft class will not be usable.
+
+    >>> cruft = Cruft()
+    >>> cruft.get_shortname()
+    Traceback (most recent call last):
+    ...
+    UnimplementedMethod: Unimplemented method: get_shortname
+    >>> cruft.cleanup()
+    Traceback (most recent call last):
+    ...
+    UnimplementedMethod: Unimplemented method: cleanup
+
+Here is a cruft subclass that is usable in a plugin.
+
+    >>> class MyCruft(Cruft):
+    ...     cruft_id = 1
+    ...     def __init__(self):
+    ...         self.cleanup_count = 0
+    ...         self._prefix = 'MyCruft{:02d}'.format(MyCruft.cruft_id)
+    ...         MyCruft.cruft_id += 1
+    ...         super(MyCruft, self).__init__()
+    ...     def get_shortname(self):
+    ...         return 'Example'
+    ...     def get_prefix(self):
+    ...         return self._prefix
+    ...     def cleanup(self):
+    ...         self.cleanup_count += 1
+
+Not only do the above methods work, but you can also use a more modern
+interface for getting information about the cruft.
+
+    >>> mycruft = MyCruft()
+    >>> print(mycruft.shortname)
+    Example
+    >>> print(mycruft.prefix)
+    MyCruft01
+    >>> print(mycruft.prefix_description)
+    <BLANKLINE>
+    >>> print(mycruft.name)
+    MyCruft01:Example
+    >>> print(mycruft.description)
+    <BLANKLINE>
+    >>> print(mycruft.disk_usage)
+    None
+    >>> mycruft.cleanup()
+    >>> mycruft.cleanup_count
+    1
+
+Cruft objects also have a reasonable repr.
+
+    >>> mycruft
+    <MyCruft "MyCruft01:Example">
+
+
+Plugins
+=======
+
+Computer Janitor plugins identify cruft.  They use whatever algorithm
+necessary to return iterators over cruft in their `get_cruft()` method.
+Plugins must derived from the abstract base class, and must override certain
+methods.
+
+    >>> from janitor.plugincore.plugin import Plugin
+    >>> Plugin().get_cruft()
+    Traceback (most recent call last):
+    ...
+    UnimplementedMethod: Unimplemented method: cleanup
+
+By subclassing the base class, we can provide a way to find cruft.
+
+    >>> class MyPlugin(Plugin):
+    ...     def __init__(self):
+    ...         self.post_cleanup_count = 0
+    ...         self._my_cruft = [MyCruft()]
+    ...         super(MyPlugin, self).__init__()
+    ...     def get_cruft(self):
+    ...         for cruft in self._my_cruft:
+    ...             yield cruft
+    ...     def post_cleanup(self):
+    ...         self.post_cleanup_count += 1
+
+Now the plugin returns one piece of cruft.
+
+    >>> plugin = MyPlugin()
+    >>> for cruft in plugin.cruft:
+    ...     print(cruft)
+    <MyCruft "MyCruft02:Example">
+
+Plugins are also the way to clean up all their cruft.
+
+    >>> plugin.do_cleanup_cruft()
+    >>> for cruft in plugin.cruft:
+    ...     print(cruft.name, 'clean ups:', cruft.cleanup_count)
+    MyCruft02:Example clean ups: 1
+
+The plugin also gets a chance to perform post-cleanup operations.
+
+    >>> plugin.post_cleanup_count
+    1
+
+For historical API reasons, plugins have conditions which are set to the empty
+list by default.
+
+    >>> plugin.condition
+    []
+
+These conditions can be set.
+
+    >>> plugin.condition = 'my condition'
+    >>> print(plugin.condition)
+    my condition
+
+Plugins also have optional applications, but by default there is no `app`
+attribute (this is for historical API reasons).
+
+    >>> print(plugin.app)
+    Traceback (most recent call last):
+    ...
+    AttributeError: app
+
+The `app` can be set through this historical API.
+
+    >>> plugin.set_application('my application')
+    >>> print(plugin.app)
+    my application
+
+
+Plugin manager
+==============
+
+The plugin manager is used to find and load plugins.  It searches a list of
+directories for files that end in `_plugin.py`.
+::
+
+    >>> from janitor.plugincore.testing.helpers import (
+    ...     setup_plugins, Application)
+    >>> plugin_dir, cleanup = setup_plugins('alpha_plugin.py')
+    >>> cleanups.append(cleanup)
+    >>> app = Application()
+
+    >>> from janitor.plugincore.manager import PluginManager
+    >>> manager = PluginManager(app, [plugin_dir])
+    >>> for filename in manager.plugin_files:
+    ...     print('plugin file:', filename)
+    plugin file: .../alpha_plugin.py
+
+The plugin manager can import each plugin module found and instantiate all
+`Plugin` base classes it finds.  After each plugin is found, a callback is
+called, which can be used to inform the user of progress.  The arguments of
+the callback are:
+
+ * The plugin filename.
+ * This plugin number in the total list of plugins found, starting from 0
+ * The total number of plugin files to be examined.
+
+    >>> def callback(filename, i, total):
+    ...     print('[{:02d}/{:02d}] {}'.format(i, total, filename))
+
+The loaded plugins are cached, so the modules are only imported once.  We'll
+use the wildcard condition which matches all plugins.
+
+    >>> plugins = manager.get_plugins(condition='*', callback=callback)
+    [00/01] .../alpha_plugin.py
+    >>> for plugin in plugins:
+    ...     print(plugin)
+    <alpha_plugin.AlphaPlugin object at ...>
+
+However, plugins can have conditions and we can use these conditions to get
+back a different set of plugins from the manager.
+
+    >>> plugins[0].condition = 'happy'
+    >>> len(manager.get_plugins(condition='sad'))
+    0
+    >>> len(manager.get_plugins(condition='happy'))
+    1

=== added file 'janitor/plugincore/docs/__init__.py'
=== added file 'janitor/plugincore/exceptions.py'
--- janitor/plugincore/exceptions.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/exceptions.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,42 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'ComputerJanitorException',
+    'UnimplementedMethod',
+    ]
+
+
+from janitor.plugincore.i18n import setup_gettext
+_ = setup_gettext()
+
+
+class ComputerJanitorException(Exception):
+    """Base class for all Computer Janitor exceptions."""
+
+
+class UnimplementedMethod(ComputerJanitorException, NotImplementedError):
+    """A method expected by the Computer Janitor API is unimplemented."""
+
+    def __init__(self, method):
+        self._method = method
+
+    def __str__(self):
+        # Why do we use %s here instead of $strings or {} format placeholders?
+        # It's because we don't want to break existing translations.
+        return _('Unimplemented method: %s') % self._method.__name__

=== added file 'janitor/plugincore/i18n.py'
--- janitor/plugincore/i18n.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/i18n.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,34 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+"""Set up the gettext context."""
+
+
+import os
+import gettext
+
+
+def setup_gettext():
+    """Set up gettext for a module."""
+    domain = 'update-manager'
+    localedir = os.environ.get('LOCPATH', None)
+    t = gettext.translation(domain, localedir=localedir, fallback=True)
+    try:
+        # We must receive unicodes from the catalog.  Python 2 by default
+        # returns 8-bit strings from the .gettext() method, so use the unicode
+        # variant.  If this doesn't exist, we're in Python 3 and there,
+        # .gettext does the right thing.
+        return t.ugettext
+    except AttributeError:
+        return t.gettext

=== added file 'janitor/plugincore/manager.py'
--- janitor/plugincore/manager.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/manager.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,185 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'PluginManager',
+    ]
+
+
+import os
+import imp
+import sys
+import errno
+import inspect
+import logging
+
+from janitor.plugincore.plugin import Plugin
+
+
+SPACE = ' '
+STR_TYPES = (basestring if str is bytes else str)
+
+
+class PluginManager:
+    """Find and load plugins.
+
+    Plugins are stored in files named '*_plugin.py' in the list of directories
+    given to the constructor.
+    """
+
+    def __init__(self, app, plugin_dirs):
+        self._app = app
+        # Make a copy to immune ourselves from mutability.  For safety, double
+        # check a common mistake.
+        if isinstance(plugin_dirs, STR_TYPES):
+            raise TypeError(
+                'Expected sequence, got {}'.format(type(plugin_dirs)))
+        self._plugin_dirs = list(plugin_dirs)
+        self._plugins = None
+
+    def get_plugin_files(self):
+        """Return all filenames in which plugins may be stored."""
+
+        for dirname in self._plugin_dirs:
+            try:
+                basenames = [filename for filename in os.listdir(dirname)
+                             if filename.endswith('_plugin.py')]
+            except OSError as error:
+                if error.errno != errno.ENOENT:
+                    raise
+                logging.debug('No such plugin directory: {}'.format(dirname))
+                continue
+            logging.debug(
+                'Plugin modules in {}: {}'.format(
+                    dirname, SPACE.join(basenames)))
+            # Sort the base names alphabetically for predictability.
+            for filename in sorted(basenames):
+                yield os.path.join(dirname, filename)
+
+    @property
+    def plugin_files(self):
+        for filename in self.get_plugin_files():
+            yield filename
+
+    def _find_plugins(self, module):
+        """Find and instantiate all plugins in a module."""
+        def is_plugin(target):
+            # Don't return the base class itself.
+            return (inspect.isclass(target) and 
+                    issubclass(target, Plugin) and
+                    target is not Plugin)
+        plugin_classes = [
+            member
+            for name, member in inspect.getmembers(module, is_plugin)
+            ]
+        logging.debug('Plugins in {}: {}'.format(
+            module, SPACE.join(str(plugin) for plugin in plugin_classes)))
+        for plugin_class in plugin_classes:
+            yield plugin_class()
+
+    def _load_module(self, filename):
+        """Load a module from a filename."""
+        logging.debug('Loading module from file {}'.format(filename))
+        # 2012-06-08 BAW: I don't particularly like putting an entry in
+        # sys.modules with the basename of the file.  Note that
+        # imp.load_module() will reload the plugin if it's already been
+        # imported, so check sys.modules first and don't reload the plugin
+        # (this is a change in behavior from older versions, but a valid one I
+        # think - reloading modules is problematic).  Ideally, we'd be using
+        # __import__() but we can't guarantee that the path to the filename is
+        # on sys.path, so we'll just live with this as the most backward
+        # compatible implementation.
+        #
+        # The other problem is that the module could be encoded, but this
+        # mechanism doesn't support PEP 263 style source file encoding
+        # specifications.  To make matters worse, we can't use codecs.open()
+        # with encoding='UTF-8' because imp.load_module() requires an actual
+        # file object, not whatever codecs wrapper is used.  If we were Python
+        # 3 only, we could use the built-in open(), but since we have to also
+        # support Python 3, we just have to live with the platform dependent
+        # default text encoding of built-in open().
+        module_name, ignore = os.path.splitext(os.path.basename(filename))
+        if module_name in sys.modules:
+            return sys.modules[module_name]
+        with open(filename, 'r') as fp:
+            try:
+                module = imp.load_module(
+                    module_name, fp, filename,
+                    ('.py', 'r', imp.PY_SOURCE))
+            except Exception as error:
+                logging.warning("Failed to load plugin '{}' ({})".format(
+                                module_name, error))
+                return None
+            else:
+                return module
+
+    def get_plugins(self, condition=None, callback=None):
+        """Return all plugins that have been found.
+
+        Loaded plugins are cached, so they will only be loaded once.
+
+        `condition` is matched against each plugin to determine whether it
+        will be returned or not.  A `condition` of the string '*' matches all
+        plugins.  The default condition matches all default plugins, since by
+        default, plugins have a condition of the empty list.
+
+        If `condition` matches the plugin's condition exactly, the plugin is
+        returned.  The plugin's condition can also be a sequence, and if
+        `condition` is in that sequence, the plugin is returned.
+
+        Note that even though loaded plugins are cached, calling
+        `get_plugin()` with different a `condition` can return a different set
+        of plugins.
+
+        If `callback` is specified, it is called after each plugin has
+        been found, with the following arguments: filename, index of
+        filename in list of files to be examined (starting with 0), and
+        total number of files to be examined. The purpose of this is to
+        allow the callback to inform the user in case things take a long
+        time.
+        """
+        # By default, plugins have a condition of the empty list, so unless a
+        # plugin has an explicit condition set, this will match everything.
+        if condition is None:
+            condition = []
+        # Only load the plugins once, however when different conditions are
+        # given, a different set of the already loaded plugins may be
+        # returned.
+        if self._plugins is None:
+            self._plugins = []
+            filenames = list(self.plugin_files)
+            total = len(filenames)
+            for i, filename in enumerate(filenames):
+                if callback is not None:
+                    callback(filename, i, total)
+                module = self._load_module(filename)
+                for plugin in self._find_plugins(module):
+                    plugin.set_application(self._app)
+                    self._plugins.append(plugin)
+        # Now match each of the plugins against the specified condition,
+        # returning only those that match, or all of them if there is no
+        # condition.
+        plugins = [
+            plugin for plugin in self._plugins
+            if (plugin.condition == condition or
+                condition in plugin.condition or
+                condition == '*')
+            ]
+        logging.debug("plugins for condition '{}' are '{}'".format(
+            condition, plugins))
+        return plugins

=== added file 'janitor/plugincore/plugin.py'
--- janitor/plugincore/plugin.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/plugin.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,81 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'Plugin',
+    ]
+
+
+from janitor.plugincore.exceptions import UnimplementedMethod
+
+
+class Plugin:
+    """Base class for plugins.
+
+    These plugins only do one thing: identify cruft. See the 'get_cruft'
+    method for details.
+    """
+
+    # XXX BAW 2012-06-08: For historical reasons, we do not set
+    # self._condition or self.app in a constructor.  This needs to be fixed.
+
+    @property
+    def condition(self):
+        return (self._condition if hasattr(self, '_condition') else [])
+
+    @condition.setter
+    def condition(self, condition):
+        self._condition = condition
+
+    def set_application(self, app):
+        """Set the Application instance this plugin belongs to."""
+        self.app = app
+
+    def do_cleanup_cruft(self):
+        """Find cruft and clean it up.
+
+        This is a helper method.
+        """
+        for cruft in self.get_cruft():
+            cruft.cleanup()
+        self.post_cleanup()
+
+    def get_cruft(self):
+        """Find some cruft in the system.
+
+        This method MUST return an iterator (see 'yield' statement).
+        This interface design allows cruft to be collected piecemeal,
+        which makes it easier to show progress in the user interface.
+
+        The base class default implementation of this raises an
+        exception. Subclasses MUST override this method.
+        """
+        raise UnimplementedMethod(self.get_cruft)
+
+    @property
+    def cruft(self):
+        for cruft in self.get_cruft():
+            yield cruft
+
+    def post_cleanup(self):
+        """Do plugin-wide cleanup after the individual cleanup was performed.
+
+        This is useful for stuff that needs to be processed in batches
+        (e.g. for performance reasons) like package removal.
+        """
+        pass

=== added directory 'janitor/plugincore/plugins'
=== added file 'janitor/plugincore/plugins/__init__.py'
=== added file 'janitor/plugincore/plugins/deb_plugin.py'
--- janitor/plugincore/plugins/deb_plugin.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/plugins/deb_plugin.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,42 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'DebPlugin',
+    ]
+
+
+import apt
+
+from janitor.plugincore.plugin import Plugin
+
+
+class DebPlugin(Plugin):
+    """Plugin for post-cleanup processing with apt.
+
+    This plugin does not find any cruft of its own.  Instead it centralizes
+    the post-cleanup handling for all packages that remove .deb packages.
+    """
+    def get_cruft(self):
+        return []
+
+    def post_cleanup(self):
+        try:
+            self.app.apt_cache.commit(apt.progress.text.AcquireProgress(),
+                                      apt.progress.base.InstallProgress())
+        finally:
+            self.app.refresh_apt_cache()

=== added file 'janitor/plugincore/plugins/dpkg_status_plugin.py'
--- janitor/plugincore/plugins/dpkg_status_plugin.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/plugins/dpkg_status_plugin.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,80 @@
+# Copyright (C) 2009-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'DpkgStatusCruft',
+    'DpkgStatusPlugin',
+    ]
+
+
+import logging
+import subprocess
+
+from apt_pkg import TagFile
+
+from janitor.plugincore.cruft import Cruft
+from janitor.plugincore.i18n import setup_gettext
+from janitor.plugincore.plugin import Plugin
+
+_ = setup_gettext()
+
+
+class DpkgStatusCruft(Cruft):
+    def __init__(self, n_items):
+        self.n_items = n_items
+
+    def get_prefix(self):
+        return 'dpkg-status'
+
+    def get_prefix_description(self):
+        return _('%i obsolete entries in the status file') % self.n_items
+
+    def get_shortname(self):
+        return _('Obsolete entries in dpkg status')
+
+    def get_description(self): # pragma: no cover
+        return _('Obsolete dpkg status entries')
+
+    def cleanup(self):
+        logging.debug('calling dpkg --forget-old-unavail')
+        res = subprocess.call('dpkg --forget-old-unavail'.split())
+        logging.debug('dpkg --forget-old-unavail returned {}'.format(res))
+
+
+class DpkgStatusPlugin(Plugin):
+    def __init__(self, filename=None):
+        self.status = ('/var/lib/dpkg/status'
+                       if filename is None
+                       else filename)
+        self.condition = ['PostCleanup']
+
+    def get_cruft(self):
+        n_cruft = 0
+        with open(self.status) as fp:
+            tagf = TagFile(fp)
+            while tagf.step():
+                statusline = tagf.section.get('Status')
+                (want, flag, status) = statusline.split()
+                if (want == 'purge' and
+                    flag == 'ok' and
+                    status == 'not-installed'):
+                    # Then...
+                    n_cruft += 1
+        logging.debug('DpkgStatusPlugin found {} cruft items'.format(n_cruft))
+        if n_cruft:
+            return [DpkgStatusCruft(n_cruft)]
+        return []

=== added file 'janitor/plugincore/plugins/kdelibs4to5_plugin.py'
--- janitor/plugincore/plugins/kdelibs4to5_plugin.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/plugins/kdelibs4to5_plugin.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,51 @@
+# Copyright (C) 2009-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+"""Install kdelibs5-dev if kdeblibs4-dev is installed."""
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'Kdelibs4devToKdelibs5devPlugin',
+    ]
+
+
+from janitor.plugincore.core.missing_package_cruft import MissingPackageCruft
+from janitor.plugincore.i18n import setup_gettext
+from janitor.plugincore.plugin import Plugin
+
+_ = setup_gettext()
+
+
+class Kdelibs4devToKdelibs5devPlugin(Plugin):
+    """Plugin to install kdelibs5-dev if kdelibs4-dev is installed.
+
+    See also LP: #279621.
+    """
+
+    def __init__(self):
+        self.condition = ['from_hardyPostDistUpgradeCache']
+
+    def get_cruft(self):
+        fromp = 'kdelibs4-dev'
+        top = 'kdelibs5-dev'
+        cache = self.app.apt_cache
+        if (fromp in cache and cache[fromp].is_installed and
+            top in cache and not cache[top].is_installed):
+                yield MissingPackageCruft(
+                    cache[top],
+                    _('When upgrading, if kdelibs4-dev is installed, '
+                      'kdelibs5-dev needs to be installed. See '
+                      'bugs.launchpad.net, bug #279621 for details.'))

=== added file 'janitor/plugincore/plugins/langpack_manual_plugin.py'
--- janitor/plugincore/plugins/langpack_manual_plugin.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/plugins/langpack_manual_plugin.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,76 @@
+# Copyright (C) 2009-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+"""Mark langpacks to be manually installed."""
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'ManualInstallCruft',
+    'MarkLangpacksManuallyInstalledPlugin',
+    ]
+
+
+import logging
+
+from janitor.plugincore.cruft import Cruft
+from janitor.plugincore.i18n import setup_gettext
+from janitor.plugincore.plugin import Plugin
+
+_ = setup_gettext()
+
+
+class ManualInstallCruft(Cruft):
+    def __init__(self, pkg):
+        self.pkg = pkg
+
+    def get_prefix(self):
+        return 'mark-manually-installed'
+
+    def get_shortname(self):
+        return self.pkg.name
+
+    def get_description(self):
+        return (_('%s needs to be marked as manually installed.') %
+                self.pkg.name)
+
+    def cleanup(self):
+        self.pkg.markKeep()
+        self.pkg.markInstall()
+
+
+class MarkLangpacksManuallyInstalledPlugin(Plugin):
+    """Plugin to mark language packs as manually installed.
+
+    This works around quirks in the hardy->intrepid upgrade.
+    """
+
+    def __init__(self):
+        self.condition = ['from_hardyPostDistUpgradeCache']
+
+    def get_cruft(self):
+        # language-support-* changed its dependencies from "recommends" to
+        # "suggests" for language-pack-* - this means that apt will think they
+        # are now auto-removalable if they got installed as a dep of
+        # language-support-* - we fix this here
+        cache = self.app.apt_cache
+        for pkg in cache:
+            if (pkg.name.startswith('language-pack-') and
+                not pkg.name.endswith('-base') and
+                cache._depcache.IsAutoInstalled(pkg._pkg) and
+                pkg.is_installed):
+                # Then...
+                logging.debug("setting '%s' to manual installed" % pkg.name)
+                yield ManualInstallCruft(pkg)

=== added file 'janitor/plugincore/plugins/remove_lilo_plugin.py'
--- janitor/plugincore/plugins/remove_lilo_plugin.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/plugins/remove_lilo_plugin.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,54 @@
+# Copyright (C) 2009  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+"""Remove lilo if grub is also installed."""
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'RemoveLiloPlugin',
+    ]
+
+
+import os
+import logging
+
+from janitor.plugincore.i18n import setup_gettext
+from janitor.plugincore.core.package_cruft import PackageCruft
+from janitor.plugincore.plugin import Plugin
+
+_ = setup_gettext()
+
+
+class RemoveLiloPlugin(Plugin):
+    """Plugin to remove lilo if grub is also installed."""
+
+    def __init__(self):
+        self.condition = ['jauntyPostDistUpgradeCache']
+
+    def get_description(self):
+        return _('Remove lilo since grub is also installed.'
+                 '(See bug #314004 for details.)')
+
+    def get_cruft(self):
+        if 'lilo' in self.app.apt_cache and 'grub' in self.app.apt_cache:
+            lilo = self.app.apt_cache['lilo']
+            grub = self.app.apt_cache['grub']
+            if lilo.is_installed and grub.is_installed:
+                if not os.path.exists('/etc/lilo.conf'):
+                    yield PackageCruft(lilo, self.description)
+                else:
+                    logging.warning('lilo and grub installed, but '
+                                    'lilo.conf exists')

=== added directory 'janitor/plugincore/testing'
=== added file 'janitor/plugincore/testing/__init__.py'
=== added file 'janitor/plugincore/testing/helpers.py'
--- janitor/plugincore/testing/helpers.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/testing/helpers.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,68 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+
+__metaclass__ = type
+__all__ = [
+    'Application',
+    'MockAptPackage',
+    'setup_plugins',
+    ]
+
+
+import os
+import shutil
+import tempfile
+import pkg_resources
+
+
+def setup_plugins(*plugin_filenames):
+    plugin_dir = tempfile.mkdtemp()
+    for filename in plugin_filenames:
+        src = pkg_resources.resource_filename(
+            'janitor.plugincore.tests.data', filename)
+        dst = os.path.join(plugin_dir, filename)
+        shutil.copyfile(src, dst)
+    return (plugin_dir, lambda: shutil.rmtree(plugin_dir))
+
+
+class Application:
+    def __init__(self):
+        self.notifications = []
+        self.commit_called = False
+        self.refresh_called = False
+        self.apt_cache = self
+
+    def commit(self, foo, bar):
+        self.commit_called = True
+
+    def refresh_apt_cache(self):
+        self.refresh_called = True
+
+
+class MockAptPackage:
+    def __init__(self):
+        self.name = 'name'
+        self.summary = 'summary'
+        self.installedSize = 12765
+        self.installed = False
+        self.deleted = False
+
+    def markInstall(self):
+        self.installed = True
+
+    def markDelete(self):
+        self.deleted = True

=== added directory 'janitor/plugincore/tests'
=== added file 'janitor/plugincore/tests/__init__.py'
=== added directory 'janitor/plugincore/tests/data'
=== added file 'janitor/plugincore/tests/data/__init__.py'
=== added file 'janitor/plugincore/tests/data/alpha_plugin.py'
--- janitor/plugincore/tests/data/alpha_plugin.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/tests/data/alpha_plugin.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,48 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+"""A test plugin."""
+
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'AlphaCruft',
+    'AlphaPlugin',
+    ]
+
+
+from janitor.plugincore.cruft import Cruft
+from janitor.plugincore.plugin import Plugin
+
+
+class AlphaCruft(Cruft):
+    def __init__(self, app):
+        self.app = app
+
+    def get_shortname(self):
+        return 'Alpha'
+
+    def cleanup(self):
+        # Tell the app we're cleaning up this cruft.
+        self.app.notifications.append((self, 'cruft'))
+
+
+class AlphaPlugin(Plugin):
+    def get_cruft(self):
+        yield AlphaCruft(self.app)
+
+    def post_cleanup(self):
+        self.app.notifications.append((self, 'post'))

=== added file 'janitor/plugincore/tests/data/bravo_plugin.py'
--- janitor/plugincore/tests/data/bravo_plugin.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/tests/data/bravo_plugin.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,48 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+"""A test plugin."""
+
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'BravoCruft',
+    'BravoPlugin',
+    ]
+
+
+from janitor.plugincore.cruft import Cruft
+from janitor.plugincore.plugin import Plugin
+
+
+class BravoCruft(Cruft):
+    def __init__(self, app):
+        self.app = app
+
+    def get_shortname(self):
+        return 'Bravo'
+
+    def cleanup(self):
+        # Tell the app we're cleaning up this cruft.
+        self.app.notifications.append((self, 'cruft'))
+
+
+class BravoPlugin(Plugin):
+    def get_cruft(self):
+        yield BravoCruft(self.app)
+
+    def post_cleanup(self):
+        self.app.notifications.append((self, 'post'))

=== added file 'janitor/plugincore/tests/data/charlie_plugin.py'
--- janitor/plugincore/tests/data/charlie_plugin.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/tests/data/charlie_plugin.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,48 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+"""A test plugin."""
+
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'CharlieCruft',
+    'CharliePlugin',
+    ]
+
+
+from janitor.plugincore.cruft import Cruft
+from janitor.plugincore.plugin import Plugin
+
+
+class CharlieCruft(Cruft):
+    def __init__(self, app):
+        self.app = app
+
+    def get_shortname(self):
+        return 'Charlie'
+
+    def cleanup(self):
+        # Tell the app we're cleaning up this cruft.
+        self.app.notifications.append((self, 'cruft'))
+
+
+class CharliePlugin(Plugin):
+    def get_cruft(self):
+        yield CharlieCruft(self.app)
+
+    def post_cleanup(self):
+        self.app.notifications.append((self, 'post'))

=== added file 'janitor/plugincore/tests/test_deb_plugin.py'
--- janitor/plugincore/tests/test_deb_plugin.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/tests/test_deb_plugin.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,44 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'DebPluginTests',
+    ]
+
+
+import unittest
+
+from janitor.plugincore.plugins.deb_plugin import DebPlugin
+from janitor.plugincore.testing.helpers import Application
+
+
+class DebPluginTests(unittest.TestCase):
+    def setUp(self):
+        self.plugin = DebPlugin()
+        self.app = Application()
+        self.plugin.set_application(self.app)
+
+    def test_no_cruft(self):
+        self.assertEqual(self.plugin.get_cruft(), [])
+
+    def test_post_cleanup_calls_commit(self):
+        self.plugin.post_cleanup()
+        self.assertTrue(self.app.commit_called)
+
+    def test_post_cleanup_calls_refresh(self):
+        self.plugin.post_cleanup()
+        self.assertTrue(self.app.refresh_called)

=== added file 'janitor/plugincore/tests/test_documentation.py'
--- janitor/plugincore/tests/test_documentation.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/tests/test_documentation.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,93 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+
+"""Test harness for doctests."""
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'additional_tests',
+    ]
+
+
+import os
+import atexit
+import doctest
+import unittest
+
+from pkg_resources import (
+    resource_filename, resource_exists, resource_listdir, cleanup_resources)
+
+
+COMMASPACE = ', '
+DOT = '.'
+DOCTEST_FLAGS = (
+    doctest.ELLIPSIS |
+    doctest.NORMALIZE_WHITESPACE |
+    doctest.REPORT_NDIFF |
+    doctest.IGNORE_EXCEPTION_DETAIL)
+
+
+WHOAMI = 'janitor.plugincore'
+
+
+
+def stop():
+    """Call into pdb.set_trace()"""
+    # Do the import here so that you get the wacky special hacked pdb instead
+    # of Python's normal pdb.
+    import pdb
+    pdb.set_trace()
+
+
+
+def setup(testobj):
+    """Test setup."""
+    # Make sure future statements in our doctests match the Python code.
+    try:
+        testobj.globs['absolute_import'] = absolute_import
+        testobj.globs['print_function'] = print_function
+        testobj.globs['unicode_literals'] = unicode_literals
+    except NameError:
+        pass
+    testobj.globs['stop'] = stop
+    testobj.globs['cleanups'] = []
+
+
+def teardown(testobj):
+    for cleanup in testobj.globs['cleanups']:
+        cleanup()
+
+
+
+def additional_tests():
+    "Run the doc tests (README.rst and docs/*, if any exist)"
+    doctest_files = [
+        ## os.path.abspath(resource_filename(WHOAMI, 'README.rst')),
+        ]
+    if resource_exists(WHOAMI, 'docs'):
+        for name in resource_listdir(WHOAMI, 'docs'):
+            if name.endswith('.rst'):
+                doctest_files.append(
+                    os.path.abspath(
+                        resource_filename(WHOAMI, 'docs/%s' % name)))
+    kwargs = dict(module_relative=False,
+                  optionflags=DOCTEST_FLAGS,
+                  setUp=setup, tearDown=teardown,
+                  )
+    atexit.register(cleanup_resources)
+    return unittest.TestSuite((
+        doctest.DocFileSuite(*doctest_files, **kwargs)))

=== added file 'janitor/plugincore/tests/test_dpkg_status_plugin.py'
--- janitor/plugincore/tests/test_dpkg_status_plugin.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/tests/test_dpkg_status_plugin.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,45 @@
+# Copyright (C) 2009-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'AutoRemovalPluginTests',
+    ]
+
+
+import os
+import tempfile
+import unittest
+
+from janitor.plugincore.plugins.dpkg_status_plugin import DpkgStatusPlugin
+
+
+class AutoRemovalPluginTests(unittest.TestCase):
+    def setUp(self):
+        fd, self.filename = tempfile.mkstemp()
+        self.addCleanup(lambda: os.remove(self.filename))
+        try:
+            os.write(fd, b'Status: purge ok not-installed\n')
+        finally:
+            os.close(fd)
+        self.plugin = DpkgStatusPlugin(self.filename)
+
+    def test_dpkg_status(self):
+        names = [cruft.get_name() for cruft in self.plugin.get_cruft()]
+        self.assertEqual(
+            sorted(names),
+            ['dpkg-status:Obsolete entries in dpkg status']
+            )

=== added file 'janitor/plugincore/tests/test_file_cruft.py'
--- janitor/plugincore/tests/test_file_cruft.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/tests/test_file_cruft.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,81 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'FileCruftTests',
+    ]
+
+
+import os
+import errno
+import tempfile
+import unittest
+import subprocess
+
+from janitor.plugincore.core.file_cruft import FileCruft
+
+
+class FileCruftTests(unittest.TestCase):
+    def setUp(self):
+        fd, self.pathname = tempfile.mkstemp()
+        def cleanup():
+            try:
+                os.remove(self.pathname)
+            except OSError as error:
+                if error.errno != errno.ENOENT:
+                    raise
+        self.addCleanup(cleanup)
+        try:
+            os.write(fd, b'x' * 1024)
+        finally:
+            os.close(fd)
+        self.cruft = FileCruft(self.pathname, 'description')
+
+    def test_refix(self):
+        self.assertEqual(self.cruft.get_prefix(), 'file')
+        self.assertEqual(self.cruft.prefix, 'file')
+
+    def test_prefix_description(self):
+        self.assertEqual(self.cruft.get_prefix_description(), 'A file on disk')
+        self.assertEqual(self.cruft.prefix_description, 'A file on disk')
+
+    def test_shortname(self):
+        self.assertEqual(self.cruft.get_shortname(), self.pathname)
+        self.assertEqual(self.cruft.shortname, self.pathname)
+
+    def test_name(self):
+        expected = 'file:{}'.format(self.pathname)
+        self.assertEqual(self.cruft.get_name(), expected)
+        self.assertEqual(self.cruft.name, expected)
+
+    def test_description(self):
+        self.assertEqual(self.cruft.get_description(), 'description\n')
+        self.assertEqual(self.cruft.description, 'description\n')
+
+    def test_disk_usage(self):
+        stdout = subprocess.check_output(
+            ('du -s -B 1 {}'.format(self.pathname)).split(),
+            # Decode output as UTF-8 and convert line endings to \n
+            universal_newlines=True)
+        du = int(stdout.splitlines()[0].split('\t')[0])
+        self.assertEqual(self.cruft.get_disk_usage(), du)
+        self.assertEqual(self.cruft.disk_usage, du)
+
+    def test_cleanup(self):
+        self.assertTrue(os.path.exists(self.pathname))
+        self.cruft.cleanup()
+        self.assertFalse(os.path.exists(self.pathname))

=== added file 'janitor/plugincore/tests/test_manager.py'
--- janitor/plugincore/tests/test_manager.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/tests/test_manager.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,171 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'ManagerTests',
+    ]
+
+
+import os
+import sys
+import unittest
+
+from janitor.plugincore.manager import PluginManager
+from janitor.plugincore.plugin import Plugin
+from janitor.plugincore.testing.helpers import setup_plugins, Application
+
+
+class ManagerTests(unittest.TestCase):
+    """Test of the plugin manager."""
+
+    def setUp(self):
+        self._app = Application()
+        self._sys_path = sys.path[:]
+
+    def tearDown(self):
+        # The tests which actually load plugins pollutes sys.path, so save and
+        # restore it around tests.
+        sys.path = self._sys_path
+
+    def test_missing_plugindir_is_ignored(self):
+        plugin_dir, cleanup = setup_plugins()
+        self.addCleanup(cleanup)
+        missing_dir = os.path.join(plugin_dir, 'does', 'not', 'exist')
+        manager = PluginManager(self._app, [missing_dir])
+        # Even though the manager is pointing to a missing plugins dir,
+        # getting all the plugin files will not crash, it will just return an
+        # empty sequence.
+        self.assertEqual(list(manager.plugin_files), [])
+
+    def test_finds_no_plugins_in_empty_directory(self):
+        plugin_dir, cleanup = setup_plugins()
+        self.addCleanup(cleanup)
+        manager = PluginManager(self._app, [plugin_dir])
+        self.assertEqual(len(manager.get_plugins()), 0)
+
+    def test_finds_one_plugin_file(self):
+        plugin_dir, cleanup = setup_plugins('alpha_plugin.py')
+        self.addCleanup(cleanup)
+        manager = PluginManager(self._app, [plugin_dir])
+        self.assertEqual(list(manager.plugin_files),
+                         [os.path.join(plugin_dir, 'alpha_plugin.py')])
+
+    def test_finds_one_plugin(self):
+        plugin_dir, cleanup = setup_plugins('alpha_plugin.py')
+        self.addCleanup(cleanup)
+        manager = PluginManager(self._app, [plugin_dir])
+        plugins = list(manager.get_plugins())
+        self.assertEqual(len(plugins), 1)
+        self.assertTrue(isinstance(plugins[0], Plugin))
+
+    def test_plugin_loading_sets_application(self):
+        plugin_dir, cleanup = setup_plugins('alpha_plugin.py')
+        self.addCleanup(cleanup)
+        manager = PluginManager(self._app, [plugin_dir])
+        plugins = list(manager.get_plugins())
+        self.assertEqual(plugins[0].app, self._app)
+
+    def test_plugin_loading_callback(self):
+        callback_calls = []
+        def callback(filename, i, total):
+            callback_calls.append((os.path.basename(filename), i, total))
+        plugin_dir, cleanup = setup_plugins('alpha_plugin.py')
+        manager = PluginManager(self._app, [plugin_dir])
+        manager.get_plugins(callback=callback)
+        self.assertEqual(callback_calls, [('alpha_plugin.py', 0, 1)])
+
+    def test_plugin_loading_callback_with_multiple_plugins(self):
+        callback_calls = []
+        def callback(filename, i, total):
+            callback_calls.append((os.path.basename(filename), i, total))
+        plugin_dir, cleanup = setup_plugins(
+            'alpha_plugin.py', 'bravo_plugin.py')
+        manager = PluginManager(self._app, [plugin_dir])
+        manager.get_plugins(callback=callback)
+        self.assertEqual(callback_calls, [
+            ('alpha_plugin.py', 0, 2),
+            ('bravo_plugin.py', 1, 2),
+            ])
+
+    def test_condition_equality(self):
+        # The first part of the conditions test looks for exactly equality
+        # between the condition argument and the plugin's condition
+        # attribute.
+        plugin_dir, cleanup = setup_plugins(
+            'alpha_plugin.py', 'bravo_plugin.py')
+        manager = PluginManager(self._app, [plugin_dir])
+        # Start by getting all the plugins.
+        all_plugins = manager.get_plugins()
+        # Set some conditions on the plugins.
+        all_plugins[0].condition = 'alpha'
+        all_plugins[1].condition = 'bravo'
+        self.assertEqual(manager.get_plugins(condition='zero'), [])
+        self.assertEqual(manager.get_plugins(condition='alpha'),
+                         [all_plugins[0]])
+        self.assertEqual(manager.get_plugins(condition='bravo'),
+                         [all_plugins[1]])
+
+    def test_condition_in(self):
+        # The second part of the conditions test checks for the given
+        # condition being in the sequence of conditions in the plugin.  This
+        # is kind of crappy because let's say a plugin's condition is
+        # 'happy_days' and you pass in condition='happy', you'll get a match.
+        # Oh well, it's been this way forever.
+        plugin_dir, cleanup = setup_plugins(
+            'alpha_plugin.py', 'bravo_plugin.py')
+        manager = PluginManager(self._app, [plugin_dir])
+        # Start by getting all the plugins.
+        all_plugins = manager.get_plugins()
+        # Set some conditions on the plugins.
+        all_plugins[0].condition = ['alpha', 'happy']
+        all_plugins[1].condition = ['bravo', 'happy', 'sad']
+        self.assertEqual(manager.get_plugins(condition='zero'), [])
+        self.assertEqual(manager.get_plugins(condition='alpha'),
+                         [all_plugins[0]])
+        self.assertEqual(manager.get_plugins(condition='bravo'),
+                         [all_plugins[1]])
+        self.assertEqual(manager.get_plugins(condition='happy'), all_plugins)
+        self.assertEqual(manager.get_plugins(condition='sad'),
+                         [all_plugins[1]])
+
+    def test_condition_wildcard(self):
+        # The third conditions test matches everything.
+        plugin_dir, cleanup = setup_plugins(
+            'alpha_plugin.py', 'bravo_plugin.py', 'charlie_plugin.py')
+        manager = PluginManager(self._app, [plugin_dir])
+        # Start by getting all the plugins.
+        all_plugins = manager.get_plugins()
+        self.assertEqual(len(all_plugins), 3)
+        # Set some conditions on the plugins.
+        all_plugins[0].condition = ['alpha', 'happy']
+        all_plugins[1].condition = ['bravo', 'happy', 'sad']
+        # Do not give the third plugin an explicit condition.
+        self.assertEqual(manager.get_plugins(condition='*'), all_plugins)
+
+    def test_condition_default_matches_conditionless(self):
+        # By default, only conditionless plugins match the manager default.
+        plugin_dir, cleanup = setup_plugins(
+            'alpha_plugin.py', 'bravo_plugin.py', 'charlie_plugin.py')
+        manager = PluginManager(self._app, [plugin_dir])
+        # Start by getting all the plugins.
+        all_plugins = manager.get_plugins()
+        self.assertEqual(len(all_plugins), 3)
+        # Set some conditions on the plugins.
+        all_plugins[0].condition = ['alpha', 'happy']
+        all_plugins[1].condition = ['bravo', 'happy', 'sad']
+        # Do not give the third plugin an explicit condition.
+        self.assertEqual(manager.get_plugins(), [all_plugins[2]])

=== added file 'janitor/plugincore/tests/test_missing_package_cruft.py'
--- janitor/plugincore/tests/test_missing_package_cruft.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/tests/test_missing_package_cruft.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,62 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'MissingPackageCruftTests',
+    ]
+
+
+import unittest
+
+from janitor.plugincore.core.missing_package_cruft import MissingPackageCruft
+from janitor.plugincore.testing.helpers import MockAptPackage
+
+
+class MissingPackageCruftTests(unittest.TestCase):
+    def setUp(self):
+        self.pkg = MockAptPackage()
+        self.cruft = MissingPackageCruft(self.pkg)
+
+    def test_prefix(self):
+        self.assertEqual(self.cruft.get_prefix(), 'install-deb')
+        self.assertEqual(self.cruft.prefix, 'install-deb')
+
+    def test_prefix_description(self):
+        self.assertTrue('Install' in self.cruft.get_prefix_description())
+        self.assertTrue('Install' in self.cruft.prefix_description)
+
+    def test_shortname(self):
+        self.assertEqual(self.cruft.get_shortname(), 'name')
+        self.assertEqual(self.cruft.shortname, 'name')
+
+    def test_name(self):
+        self.assertEqual(self.cruft.get_name(), 'install-deb:name')
+        self.assertEqual(self.cruft.name, 'install-deb:name')
+
+    def test_description(self):
+        self.assertTrue('name' in self.cruft.get_description())
+        self.assertTrue('name' in self.cruft.description)
+
+    def test_explicit_description(self):
+        pkg = MissingPackageCruft(self.pkg, 'foo')
+        self.assertEqual(pkg.get_description(), 'foo')
+        self.assertEqual(pkg.description, 'foo')
+
+    def test_cleanup(self):
+        self.cruft.cleanup()
+        self.assertTrue(self.pkg.installed)

=== added file 'janitor/plugincore/tests/test_package_cruft.py'
--- janitor/plugincore/tests/test_package_cruft.py	1970-01-01 00:00:00 +0000
+++ janitor/plugincore/tests/test_package_cruft.py	2012-06-11 15:08:35 +0000
@@ -0,0 +1,62 @@
+# Copyright (C) 2008-2012  Canonical, Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation, version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program.  If not, see <http://www.gnu.org/licenses/>.
+
+from __future__ import absolute_import, print_function, unicode_literals
+
+__metaclass__ = type
+__all__ = [
+    'PackageCruftTests',
+    ]
+
+
+
+import unittest
+
+from janitor.plugincore.core.package_cruft import PackageCruft
+from janitor.plugincore.testing.helpers import MockAptPackage
+
+
+class PackageCruftTests(unittest.TestCase):
+    def setUp(self):
+        self.pkg = MockAptPackage()
+        self.cruft = PackageCruft(self.pkg, 'description')
+
+    def test_prefix(self):
+        self.assertEqual(self.cruft.get_prefix(), 'deb')
+        self.assertEqual(self.cruft.prefix, 'deb')
+
+    def test_prefix_description(self):
+        self.assertEqual(self.cruft.get_prefix_description(), '.deb package')
+        self.assertEqual(self.cruft.prefix_description, '.deb package')
+
+    def test_shortname(self):
+        self.assertEqual(self.cruft.get_shortname(), 'name')
+        self.assertEqual(self.cruft.shortname, 'name')
+
+    def test_name(self):
+        self.assertEqual(self.cruft.get_name(), 'deb:name')
+        self.assertEqual(self.cruft.name, 'deb:name')
+
+    def test_description(self):
+        self.assertEqual(self.cruft.get_description(),
+                         'description\n\nsummary')
+        self.assertEqual(self.cruft.description, 'description\n\nsummary')
+
+    def test_disk_usage(self):
+        self.assertEqual(self.cruft.get_disk_usage(), 12765)
+        self.assertEqual(self.cruft.disk_usage, 12765)
+
+    def test_cleanup(self):
+        self.cruft.cleanup()
+        self.assertTrue(self.pkg.deleted)

=== modified file 'po/POTFILES.in'
--- po/POTFILES.in	2011-11-27 22:50:26 +0000
+++ po/POTFILES.in	2012-06-11 15:08:35 +0000
@@ -38,24 +38,35 @@
 do-release-upgrade
 check-new-release-gtk
 ubuntu-support-status
-Janitor/computerjanitor/cruft.py
-Janitor/computerjanitor/cruft_tests.py
-Janitor/computerjanitor/exc.py
-Janitor/computerjanitor/exc_tests.py
-Janitor/computerjanitor/file_cruft.py
-Janitor/computerjanitor/file_cruft_tests.py
-Janitor/computerjanitor/__init__.py
-Janitor/computerjanitor/package_cruft.py
-Janitor/computerjanitor/package_cruft_tests.py
-Janitor/computerjanitor/plugin.py
-Janitor/computerjanitor/plugin_tests.py
-Janitor/computerjanitor/missing_package_cruft.py
-Janitor/computerjanitor/missing_package_cruft_tests.py
-Janitor/plugins/deb_plugin.py
-Janitor/plugins/deb_plugin_tests.py
-Janitor/plugins/dpkg_status_plugin.py
-Janitor/plugins/dpkg_status_plugin_tests.py
-Janitor/plugins/kdelibs4to5_plugin.py
-Janitor/plugins/langpack_manual_plugin.py
-Janitor/plugins/remove_lilo_plugin.py
-
+janitor/plugincore/cruft.py
+janitor/plugincore/docs/__init__.py
+janitor/plugincore/testing/helpers.py
+janitor/plugincore/testing/__init__.py
+janitor/plugincore/exceptions.py
+janitor/plugincore/core/file_cruft.py
+janitor/plugincore/core/missing_package_cruft.py
+janitor/plugincore/core/package_cruft.py
+janitor/plugincore/core/__init__.py
+janitor/plugincore/plugin.py
+janitor/plugincore/__init__.py
+janitor/plugincore/manager.py
+janitor/plugincore/i18n.py
+janitor/plugincore/plugins/langpack_manual_plugin.py
+janitor/plugincore/plugins/kdelibs4to5_plugin.py
+janitor/plugincore/plugins/dpkg_status_plugin.py
+janitor/plugincore/plugins/deb_plugin.py
+janitor/plugincore/plugins/__init__.py
+janitor/plugincore/plugins/remove_lilo_plugin.py
+janitor/plugincore/tests/test_dpkg_status_plugin.py
+janitor/plugincore/tests/test_file_cruft.py
+janitor/plugincore/tests/test_missing_package_cruft.py
+janitor/plugincore/tests/__init__.py
+janitor/plugincore/tests/test_documentation.py
+janitor/plugincore/tests/test_package_cruft.py
+janitor/plugincore/tests/test_manager.py
+janitor/plugincore/tests/test_deb_plugin.py
+janitor/plugincore/tests/data/bravo_plugin.py
+janitor/plugincore/tests/data/__init__.py
+janitor/plugincore/tests/data/alpha_plugin.py
+janitor/plugincore/tests/data/charlie_plugin.py
+janitor/__init__.py

=== modified file 'setup.py'
--- setup.py	2012-06-07 20:21:39 +0000
+++ setup.py	2012-06-11 15:08:35 +0000
@@ -12,9 +12,9 @@
 
 def plugins():
     return []
-    ## return [os.path.join('Janitor/plugins', name)
-    ##         for name in os.listdir('Janitor/plugins')
-    ##         if name.endswith('_plugin.py') and name not in disabled]
+    return [os.path.join('janitor/plugincore/plugins', name)
+            for name in os.listdir('janitor/plugincore/plugins')
+            if name.endswith('_plugin.py') and name not in disabled]
 
 def profiles():
     profiles = []
@@ -37,13 +37,13 @@
                 'UpdateManager.Core',
                 'UpdateManagerText',
                 'DistUpgrade',
-                #'computerjanitor',
+                'janitor',
                 'AutoUpgradeTester',
                 ],
-      ## package_dir={
-      ##              '': '.',
-      ##              'computerjanitor': 'Janitor/computerjanitor',
-      ##             },
+      package_dir={
+                   '': '.',
+                   'janitor.plugincore': 'janitor/plugincore',
+                  },
       scripts=[
                'update-manager', 
                'ubuntu-support-status', 
@@ -69,8 +69,8 @@
                    ['data/update-manager.convert']),
                   ('../etc/update-manager/',
                    ['data/release-upgrades', 'data/meta-release']),
-                  ## ('share/computerjanitor/plugins',
-                  ##  plugins()),
+                  ('share/computerjanitor/plugins',
+                   plugins()),
                   ('share/auto-upgrade-tester/post_upgrade_tests',
                    glob.glob("AutoUpgradeTester/post_upgrade_tests/*")),
                   ]+profiles(),

